# Traveller  - a monophonic with a twist

![](traveller.png)

It was inspired by [Korg Synthe-Bass](https://www.youtube.com/watch?v=-sgVuiCfxGI) and it's overall simplicity.

It features:

- **one oscillator** with **six** different waveforms (two of these are actually PWM-modulated square and one is noise)
- twisted **monophony**
- **traveller** slider (filter cuttoff)
- **slow/instant** slider (attack time)
- **bump/singing** slider (release time)
- **hold** switch (sustain on/off)
- **bite** switch (resonance on/off)
- **quack** switch (filter follows envelope on/off)
- and most importantly - **volume** knob :-)

The twist (in monophony) is that while you cannot hold two or more notes, you can hear previous note release while next one kicks in. This is actually implementation defect, but I left it as is because it adds character to the synth.

There are no presets as I believe limitations stimulates creativity but there is [demo video](https://youtu.be/bsX3pl3u2hc) to inspire you.

## Good to know

- it will not start without csound64.dll in plugin folder
- it's portable - but I will have to ask my friend to produce Mac version as I have no Apple computer
- it's open source - just open traveller.csd and examine or change code
- it has no velocity sensitivity, but tone depends on how long you hold the key (for tones with long attack)
- you can use pitch bend wheel

## Changelog

- version 1.1 - fixed issue with stereo sound (right channel muted), added VST3 format

## Download links

- repository with source code - https://tildegit.org/severak/falco
- KVR audio page with binaries- https://www.kvraudio.com/product/traveller-by-sever-k

---

> When the technique is primitive, everything is beautiful, and when the technique is perfected, almost everything is ugly.
> -- Jean Renoir
